
% Solves part d for the value p=0.5
% To solve for other values of p, just change 
% the number below

% April 11, 1999
% Developed by Ali H. Sayed


clear

L=1000;

N=10;

p=0.5;

x=psk(p);

for j=1:L
 y=x+randn(N,1);
 z=sum(y);
 xopt(j)=tanh(0.5*log(p/(1-p))+z);
 xavg(j)=z/N;
 xdec(j)=sign(xopt(j));
 xsgn(j)=sign(xavg(j));

 if xdec(j)==0  xdec(j)=1; end  %The sign function of matlab returns zero
 if xsgn(j)==0  xsgn(j)=1; end  %if argument is zero.

end


d1=(x-xopt).^2;      
d2=(x-xavg).^2;
d3=(x-xdec).^2;
d4=(x-xsgn).^2;

s1=mean(d1);  % variance for optimal estimator
s2=mean(d2);  % variance for average estimator
s3=mean(d3);  % variance for sgn[optimal]
s4=mean(d4);  % variance for sgn[average]
s=[s1 s2 s3 s4]

clf;

subplot(211)
stem(s);
title('Sample variances');
grid
