
% Solves part (b). The values of alpha, beta, and the 
% variance of v, denoted by var_v, can be changed.


% January 14, 2000
% Developed by Ali H. Sayed


clear all
close all

var_v =  1;
alpha = -0.4;
beta  = -0.4;

rho = (1+beta+abs(alpha))/(1+beta-abs(alpha));
disp([' Eigenvaluespread = ', num2str(rho)]);

mu_o=(1-beta)/(1+beta);
mu_o=mu_o*((1+beta)^2-alpha^2)/var_v;
disp([' Optimal step-size = ', num2str(mu_o)]);

C = var_v/((1-beta)*((1+beta)^2 - alpha^2));
Ru = C*[1+beta -alpha
        -alpha  1+beta];
Rdu = C*[-alpha
          alpha^2-beta-beta^2];

mu = [0.01 0.05 mu_o];
s = ['xg--'; 'dr--'; '+m--'];


for k = 1:length(mu), 

 N=70;             % number of iterations;
 we=zeros(2,N);
 J=zeros(1,N);
 w_init = [-10 10]';  % initial weight estimate;

 w=w_init;
 J(1) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;  % cost
 we(:,1)=w;

for i = 2:N,
  w = w + mu(k)*(Rdu - Ru*w);
  J(i) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;
  we(:,i)=w;
end;

plot(0:N-1,J, s(k,:));
%axis([1 30 0.6 J(1)*1.3]);
hold on
end;
legend('\mu=0.01','\mu=0.05','\mu=\mu^o');
grid
xlabel('iteration');
ylabel('E|e(i)|^2');
title('Learning curves for \alpha = -0.4, \beta = -0.4, \rho = 5, and with various \mu');
