%
% Solves part (c). Allows the user to change the 
% values of alpha and of the variance of the noise,
% var_v.



% January 14, 2000
% Developed by Ali H. Sayed


clear all
close all

var_v =  1;

s = ['xg--'; 'dr--'; '+m--'; 'b-o '];
rho = [5 10 30 50];

alpha = -0.4;

for k = 1:length(rho),
  
  beta = abs(alpha)*(1 + rho(k))/(rho(k) - 1) - 1;
  disp([' beta = ', num2str(beta)]);
  mu_o=(1-beta)/(1+beta);
  mu_o=mu_o*((1+beta)^2-alpha^2)/var_v;  %optimal step-size

  C = var_v/((1-beta)*((1+beta)^2 - alpha^2));
  Ru = C*[1+beta -alpha
          -alpha  1+beta];
  Rdu = C*[-alpha
            alpha^2-beta-beta^2];


  N=70;             % number of iterations;
  we=zeros(2,N);
  J=zeros(1,N);
  w_init = [-10 10]';  % initial weight estimate;
  w=w_init;
  J(1) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;  % cost
  we(:,1)=w;

  for i = 2:N,
    w = w + mu_o*(Rdu - Ru*w);
    J(i) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;
    we(:,i)=w;
  end;
  
  plot(0:N-1,J, s(k,:));
  hold on

 end;

legend('\rho=5','\rho=10','\rho=30','\rho=50');
grid
title('The larger the eigenvalue spread \rho, the slower the convergence!');
xlabel('i');
ylabel('E|e(i)|^2');
