%
% Solves part (d). Allows the user to change the 
% values of alpha, beta, and the variance of the noise,
% var_v. Also, the values of the step-size (vector mu), 
% and the initial weight estimate, w_init, can be 
% changed.
%

% January 14, 2000
% Developed by Ali H. Sayed


clear all
close all

var_v = 1;
alpha=-0.4;
beta=-0.4;


mu_o=(1-beta)/(1+beta);
mu_o=mu_o*((1+beta)^2-alpha^2)/var_v;

C = var_v/((1-beta)*((1+beta)^2 - alpha^2));
Ru = C*[1+beta -alpha
        -alpha  1+beta];
Rdu = C*[-alpha
          alpha^2-beta-beta^2];

lambda_max=max(eig(Ru));

mu = [0.1, mu_o, 2/lambda_max];


w1o = [-3.5:0.05:3.5];  % ranges for the entries of w
w2o = [-3.5:0.05:3.5]';

L = length(w1o);



J=zeros(L,L);       % evaluation of the cost function on a grid
for i=1:L
  for j=1:L
   w=[w1o(i) w2o(j)]';
   J(i,j) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;
  end
end

display('Now count to 3!');

for k = 1:length(mu),
 k
 N=40;             % number of iterations;
 we=zeros(2,N);
 Je=zeros(1,N);
 w_init = [2 1]';  % initial weight estimate;

 w=w_init;
 Je(1) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;  % cost
 we(:,1)=w;

 for i = 2:N,
   w = w + mu(k)*(Rdu - Ru*w);
   Je(i) = Ru(1,1) - Rdu'*w -w'*Rdu + w'*Ru*w;
   we(:,i)=w;
 end;


switch k
case 1
     subplot(311);
case 2
     subplot(312);
case 3
     subplot(313);
end


   
contour(w1o, w2o, J, Je);
colorbar;
xlabel('w_i(1)');
ylabel('w_i(2)');
s = strcat('Contour curves and trajectory for \mu = ', num2str(mu(k)));
title(s);
hold on
plot(we(1,:), we(2,:));
hold off
zoom on

end
