
% Solves part (e). The values of alpha, beta, and the 
% variance of v, denoted by var_v, can be changed.


% January 14, 2000
% Developed by Ali H. Sayed


clear all
close all

var_v =  1;
alpha = -0.4;
beta  = -0.4;

C = var_v/((1-beta)*((1+beta)^2 - alpha^2));
Ru = C*[1+beta -alpha
        -alpha  1+beta];
Rdu = C*[-alpha
          alpha^2-beta-beta^2];

N=30;
w1_init = [2 1]';
w2_init = [2 1]';
J1=zeros(1,N);
J2=zeros(1,N);

w1=w1_init;
w2=w2_init;

J1(1) = Ru(1,1) - Rdu'*w1 -w1'*Rdu + w1'*Ru*w1;
J2(1) = Ru(1,1) - Rdu'*w2 -w2'*Rdu + w2'*Ru*w2;

for i = 2:N,
  w1 = w1 + 2/(i+1)*(Rdu - Ru*w1);
  J1(i) = Ru(1,1) - Rdu'*w1 - w1'*Rdu + w1'*Ru*w1;

  mo = (w2'*Ru^2*w2)/(w2'*Ru^3*w2);
  w2 = w2 + mo*(Rdu - Ru*w2);
  J2(i) = Ru(1,1) - Rdu'*w2 - w2'*Rdu + w2'*Ru*w2;
end

s = ['xg--'; 'dr--'; '+m--'];


plot(0:N-1,J1,'xg--',0:N-1,J2,'dr--');
legend('\mu(i) = 2/(i+1)', '\mu^o(i)');
grid
xlabel('i');
title('Comparison of learning curves with two time-variant step-sizes')
ylabel('E|e(i)|^2');

