
%Blind adaptive equalization project from chapter 5
%Solves part E (learning curves). Too slow --> not used.

%Developed by A. H. Sayed

clear all;  
close all

SNR = 60 % SNR at output of channel
equalizer_length = 35;
mu = 0.0001;
N=30000; % total number of symbols
s=zeros(1,N);


%Channel
 channel=[0.5 1.2 1.5 -1]; % from chapter 3. 


L=100; %experiments
gammavec=[13.2 13.2 3.3385 2.5 2.5];  % gamma values for 16-QAM and for 5 blind algorithms

E=zeros(5,N);
for alg=3:3
    % 1-->CMA2-2
    % 2-->MMA
    % 3-->CMA1-2
    % 4-->RCA
    % 5-->Stop-and-go
 
 gamma=gammavec(alg);

  
 for kk=1:L
  [alg kk]

  qam=16; % constellation
  switch qam
    case 4
      sigma_s = sqrt(2);
    case 16
      sigma_s = sqrt(10);
    case 64
      sigma_s = sqrt(42);
    case 256
      sigma_s = sqrt(170);
   end

  %Noise
  sigma_v= sqrt((sigma_s)^2*norm(channel)^2/10^(SNR/10)); 
  v=zeros(1,N);
  v(1:N)=(sigma_v/2)*(randn(1,N)+j*randn(1,N));


  %Data
  for i=1:N
   x=rand;   
   xint=round((qam-1)*x); % generates integers, e.g., between 0 and 255
   xcoor=modmap(xint,1,1,'qam',qam); % gives real and imaginary coordinates
   s(i)=xcoor(1) + j*xcoor(2); % combines them into a complex number
  end 
  y=filter(channel,1,s); % filters data through channel
  r=y+v; % received data
   
     
  % Equalizer initialization
   w  = zeros(equalizer_length,1); % equalizer coefficients (column) 
   w(ceil(equalizer_length/2))= 1;  % initial condition cannot be zero for MMA!
   u  = zeros(1,equalizer_length); % regressor vector (row) 
   e = zeros(1,N); % error vector

% Blind adaptive equalization
 for i = 1:N
   u  = [r(i) u(1:equalizer_length-1)];
   hat_s(i) = u*w;
   check_s(i) = slicer16(hat_s(i));
 
   switch alg
   case 1 % CMA2-2
      e(i) = hat_s(i)*(gamma-(hat_s(i)*hat_s(i)')); % CMA2-2
      w = w + mu*e(i)*u';
   case 2 % MMA
      a  = real(hat_s(i));
      b  = imag(hat_s(i));
      e1 = a*(gamma - a^2);
      e2 = b*(gamma - b^2);
      e(i) = e1 + j*e2; % MMA
      w = w + mu*e(i)*u';
   case 3 % CMA1-2
      if hat_s(i)==0 
        e(i)=0;
      else
        e(i) = (gamma*hat_s(i)/abs(hat_s(i))) - hat_s(i);
      end
      w = w + mu*e(i)*u';
   case 4 % RCA
      a  = real(hat_s(i));
      b  = imag(hat_s(i));
      if a>=0
         a=1;
      else
         a=-1;
      end
      if b>=0
         b=1;
      else
         b=-1;
      end
      e(i)= gamma*(a+j*b) - hat_s(i);
      w = w + mu*e(i)*u';
   case 5 % Stop-and-go
      a  = real(hat_s(i));
      b  = imag(hat_s(i));
      if a>=0
         a=1;
      else
         a=-1;
      end
      if b>=0
         b=1;
      else
         b=-1;
      end
      e_s(i)= gamma*(a+j*b) - hat_s(i);
      e_d(i)= check_s(i) - hat_s(i);       
      
      if sign(real(e_s(i))) == sign(real(e_d(i)))
         if sign(imag(e_s(i))) == sign(imag(e_d(i)))
            flag=1;
        end
     end
         
     e(i)= flag*e_d(i);
     w = w+mu*e(i)*u';
     flag = 0;
   end
   e(i)=abs(e(i))^2;
 end
    E(alg,:)=E(alg,:) + e;
 end
 E(alg,:)=E(alg,:)/L;
end

save E E

figure
plot(1:N,10*log10(E(1,:)),'b',1:N,10*log10(E(2,:)),'r',1:N,10*log10(E(3,:)),'m',1:N,10*log10(E(4,:)),'g',1:N,10*log10(E(5,:)),'k');
legend('CMA22','MMA','CMA12','RCA','SG');
xlabel('i');
ylabel('dB');