len
% Adaptive Line Echo Canceller
% Solves part F

% Written by Ali H. Sayed 
% Mar. 2002


close all
clear all       % clears all variables


load path.mat;  % loads the echo path model
load css.mat;   % loads the CSS data

far_end_unit_power = [];
for i=1:10
    far_end_unit_power = [far_end_unit_power css];
end

N = length(far_end_unit_power);

M=128; 
mu = 0.25; % step-size for e-NLMS
epsilon = 1e-6;

far_end = far_end_unit_power; 
echo = filter(path,1,far_end);
w = zeros(M,1); % weight estimate
u = zeros(1,M); % regressor

disp('Please be patient...This takes a while...')

for i=1:N
  u = [far_end(i) u(1:M-1)];
  e(i) = echo(i) - u*w;
  factor = epsilon + (norm(u)^2);
  w = w + (mu/factor)*u'*e(i);  % e-NLMS
end

Pecho  = 10*log10((norm(echo(N-5600:N))^2/5600));
Perror = 10*log10((norm(e(N-5600:N))^2)/5600);
ERLE  = Pecho - Perror


figure
subplot(311)
plot(1:N,far_end);
title('Far-end signal');
axis([0 N -5 5]);

subplot(312)
plot(1:N,echo);
title('Echo signal');
axis([0 N -5 5]);

subplot(313)
plot(1:N,e);
title('Error signal');
axis([0 N -5 5]);


figure
Lp = max(size(path));
path_e=[path zeros(1,M-Lp)];
plot(0:M-1,path_e,'-.',0:M-1,w,'r');
title('Echo path impulse response and its estimate');
legend('Echo path','Path estimate');
axis([0 M-1 -0.2 0.15])
