
% Adaptive Line Echo Canceller
% Solves part F

% Written by Ali H. Sayed 
% Mar. 2002


close all
clear all       % clears all variables


load path.mat;  % loads the echo path model
load css.mat;   % loads the CSS data

far_end_unit_power = [];
for i=1:10
    far_end_unit_power = [far_end_unit_power css];
end

N = length(far_end_unit_power);

M=128; 
mu = 0.25; % step-size for e-NLMS
epsilon = 1e-6;

disp('Please be patient...This takes a while...')
k=0;

for powerdb = 0:-5:-25
  powerdb  
  k=k+1;
  power = 10^(powerdb/10); 
  far_end = far_end_unit_power*sqrt(power); 
  echo = filter(path,1,far_end);
  w = zeros(M,1); % weight estimate
  u = zeros(1,M); % regressor

  for i=1:N
    u = [far_end(i) u(1:M-1)];
    e(i) = echo(i) - u*w;
    factor = epsilon + (norm(u)^2);
    w = w + (mu/factor)*u'*e(i);  % e-NLMS
  end

  Pecho  = 10*log10((norm(echo(N-5600:N))^2/5600));
  Perror = 10*log10((norm(e(N-5600:N))^2)/5600);
  ERLE(k)  = Pecho - Perror;
end

powerdb = 0:-5:-25;
figure
plot(powerdb,ERLE,'b-o');
ylabel('ERLE (dB)');
xlabel('Far-end power (dB)');
axis tight;