
% Adaptive Line Echo Canceller
% Solves part H

% Written by Ali H. Sayed 
% Mar. 2002


close all
clear all       % clears all variables


load path.mat;   % loads the echo path model
load speech.mat  % loads a speech signal

far_end = speech;
echo = filter(path,1,far_end);
N = length(far_end);

M=128; 
mu = 0.25; % step-size for e-NLMS
epsilon = 1e-6;

w = zeros(M,1); % weight estimate
u = zeros(1,M); % regressor

disp('Please wait for a while...')

for i=1:N
  u = [far_end(i) u(1:M-1)];
  e(i) = echo(i) - u*w;
  factor = epsilon + (norm(u)^2);
  w = w + (mu/factor)*u'*e(i);  % e-NLMS
  if mod(i,1000)==0
      i
  end
end

figure
subplot(311)
plot(far_end)
legend('Far-end');
axis([1 14000 -1 1]);
grid
subplot(312)
plot(echo)
legend('Echo')
axis([1 14000 -1 1]);
grid
subplot(313)
plot(e)
legend('Error')
xlabel('i')
grid
axis([1 14000 -1 1]);

response = 'y';

 display('Let us now hear the signals')
 while response =='y' | response == 'Y',
   display('Press a key to hear the far-end signal');
   pause
   sound(far_end);
   display('Press a key to hear the echo');
   pause
   sound(echo);
   display('Press a key to hear the error');
   pause
   sound(e);
   response=input('Do you want to hear the signals again? Y/N     ','s');
 end
