
% Solves part A
% LMS
% A. H. Sayed

 close all;
 clear all;

 N = 10000;  % number of iterations
 L = 30;     % number of experiments

 Br = 13;    % number of data bits (including sign bit)
 Bc = 13;    % number of coefficient bits (including sign bit)
 
 M = 5; % number of taps
 wo = randn(M,1);
 wo = wo/norm(wo);
 wo = quantize_v(wo,Bc);

 var_n = 0.001; % Gaussian noise
 sqn   = sqrt(var_n);

 mu_vec = [0.01:0.01:0.1];
 K = length(mu_vec);

 for l=1:K
   mu = mu_vec(l);
   learn = zeros(1,N);
   for k=1:L
       
      input = randn(1,N+M); % input data
      v = sqn*randn(1,N+M); %  white Gaussian noise 
      w = zeros(M,1); 

      k
      for i=1:N
         u = quantize_v(input(i:i+M-1),Br); 
         d = u*wo + v(i);
         d = quantize(d,Br);
         d_hat = u*w;
         d_hat = quantize(d_hat,Br);
         e(i) = quantize(d-d_hat,Br);
         w = w + quantize_v((mu*u'*e(i)),Bc);  % LMS algorithm
         w = quantize_v(w,Bc);
      end;
      learn = learn + abs(e).^2;
   end
                 
  learn = learn/L;
  
  var_c = 2^(-2*(Bc-1))/12;
  var_r = 2^(-2*(Br-1))/12;

  R = eye(M,M);
  var_n_bar = var_n +  3*var_r + 2*var_c*trace(R);

  Q = 0;
  Q_bar = Q + 2*var_c*eye(M,M);
  R_bar = R + var_c*eye(M,M);
  
  a = mu*var_n_bar*trace(R_bar);
  b = (1/mu)*trace(Q_bar);
  c = (2-mu*trace(R_bar));

  sim(l) = sum(learn(N-999:N))/1000
  thy(l) = var_n + ((a+b)/c) + 2*var_c*trace(R)
end

figure(1)
plot(mu_vec, sim,'vk--',mu_vec, thy,'xr-')
grid
xlabel('\mu')
ylabel('MSE')
legend('Simulation','Theory')



