
%CDMA
%part B

%*********************************** CDMA *********************************
%*********            Two Users, Known Single Tap Channel
%*********               Non-Orthogonal(Least-Squares Receiver)
%*********                      PN Sequences
%**************************************************************************
clear all;
close all;
%Non-Orthogonal PN Sequences
s1=[1,-1,-1,-1,-1,1,1,1,-1,-1,1,1,-1,1,1,-1]; 
s2=[-1,-1,1,-1,1,-1,-1,-1,1,-1,-1,1,-1,1,-1,1];

%*********************** Correlation Factor ***********************
r=s1*s2';

Lc=16;
%Channel Single Tap
h=[1;1];
snr=-20:1:0;
%noise variance in different SNR
Sv=norm(h(1,:))*(10.^(-snr/10));
%Number of Symbols in each SNR
N=200; 
S1=[];
S2=[];

%Number of Time Repeating 
Navg=400;
%******************Tranmitter*************************
for t=1:Navg
   ['Progress: ',num2str(t*100/Navg),'%']
   for j=1:length(snr)
   v=(Sv(j))^.5*randn(1,Lc*N);
   b1=2*(randint(N,1)-0.5);  %user 1 data transmitting
   b2=2*(randint(N,1)-0.5);  %user 2 data transmitting
   t1=[];
   t2=[];
   for i=1:N
      t1=[t1 b1(i)*s1];
      t2=[t2 b2(i)*s2];
   end
   %Transmitted Data for N symbol
   T=h(1)*t1+h(2)*t2;  
   
%******************Receiver*************************
%Received Data for N symbol
   R=T+v;    
%Correlation
   y1=[];
   y2=[];
   for i=1:N
      y1(i)=R(Lc*(i-1)+1:Lc*i)*s1';
      y2(i)=R(Lc*(i-1)+1:Lc*i)*s2';
   end

%***************Multi User Decision***************   
   bhat1_ls=sign((1/(Lc^2-r^2))*(Lc*y1-r*y2));
   bhat2_ls=sign((1/(Lc^2-r^2))*(Lc*y2-r*y1));
   
%***************Sign Detector  ***************   
   bhat1=sign(y1);
   bhat2=sign(y2);
%*********Error Probabilitis ***********************   
   er1(j)=(length(find(bhat1~=b1')))/N;
   er2(j)=(length(find(bhat2~=b2')))/N;
   
   er1_ls(j)=(length(find(bhat1_ls~=b1')))/N;
   er2_ls(j)=(length(find(bhat2_ls~=b2')))/N;
   
   
end
eer1(t,:)=er1;
eer2(t,:)=er2;

eer1_ls(t,:)=er1_ls;
eer2_ls(t,:)=er2_ls;

end

%********************* Plotting ********************
BER1=mean(eer1);
BER2=mean(eer2);

BER1_ls=mean(eer1_ls);
BER2_ls=mean(eer2_ls);

semilogy(snr,BER1,'rs-',snr,BER1_ls,'bo-');
legend('Sign Detector','LS detector');
grid on;
xlabel('SNR (dB)');
ylabel('BER');
title('Single tap channel- Two users - Known Channel');




   

    

   
   
   
   
   
   



 
