
% Regularization and least-squares

% Solves part A

% Written by Ali H. Sayed 
% September 2002


close all
clear all       % clears all variables


N = 60;
a = 2*(rand-0.5);  % uniform between -1 and 1
var_a = 1/12;

SNR_v = [10 20 30];
K = max(size(SNR_v));

yhat = zeros(N+1,K);
y = zeros(N+1,K);

for kk=1:K
    
  SNR = SNR_v(kk)
  var_v = var_a*10^(-SNR/10);
  v = sqrt(var_v)*randn(N+1,1);

  f0 = 0.1;
  index = 0:N;
  y(:,kk) = a*cos(2*pi*f0*index') + v;

  H = zeros(N,1);
  for k=0:N
   H(k+1) = cos(2*pi*k*f0);
  end

  alpha = var_v/var_a
  
  r = H'*y(:,kk); 
  C = (alpha + H'*H);

  ahat = inv(C)*r;
  yhat(:,kk) = ahat*cos(2*pi*f0*index');
end


subplot(311)
plot(1:N+1,y(:,1),'b-d',1:N+1,yhat(:,1),'r-.')
axis([0 60 -1 1]);
axis tight;
legend('10dB')
subplot(312)
plot(1:N+1,y(:,2),'b-d',1:N+1,yhat(:,2),'r-.')
axis([0 60 -1 1]);
axis tight;
legend('20dB')
subplot(313)
plot(1:N+1,y(:,3),'b-d',1:N+1,yhat(:,3),'r-.')
axis([0 60 -1 1]);
axis tight;
legend('30dB')
xlabel('i');
