
% Regularization and least-squares

% Solves part B

% Written by Ali H. Sayed 
% September 2002


close all
clear all       % clears all variables


N = 100;
SNR = 10;

L = 100; % experiments

range = 0:0.01:5;
R = max(size(range));
e = zeros(R,1);
ea = zeros(R,1);

for rr=1:R
  alpha = range(rr)
  for i=1:L
    a = 2*(rand-0.5);  % uniform between -1 and 1
    var_a = 1/12;

    var_v = var_a*10^(-SNR/10);
    v = sqrt(var_v)*randn(N+1,1);

    f0 = 0.1;
    index = 0:N;
    y = a*cos(2*pi*f0*index') + v;

    H = zeros(N,1);
    for k=0:N
     H(k+1) = cos(2*pi*k*f0);
    end

    r = H'*y; 
    C = (alpha + H'*H);

    ahat = inv(C)*r;
    yhat = ahat*cos(2*pi*f0*index');
    e(rr) = e(rr) + (norm(y-yhat)^2/N);
    ea(rr) = ea(rr) + abs(a-ahat)^2;
  end
end
e=e/L;
ea=ea/L;

subplot(211)
plot(range,10*log10(ea))
ylabel('dB');
legend('variance of error in a');
subplot(212)
plot(range,10*log10(e))
xlabel('\alpha')
ylabel('dB');
legend('variance of error in y');