
function [e,w] = rls(input,d,lambda,eta,order,Po);

%  RLS algorithm
% returns the a-priori output error sequence and last weight vector

% Ali H. Sayed
% Sep. 2002

N = max(size(input));
M = order;

w = zeros(M,1);
u = zeros(1,M);
P = Po;

for i=1:N
  u = [input(i) u(1:M-1)];
  e(i) = d(i) - u*w; 
  gamma = 1/(1+(1/lambda)*u*P*u'); 
  g = (1/lambda)*P*u'*gamma; 
  w = w + g*e(i);  
  P = (1/lambda)*P - (g*g'/gamma);
end

