
% Laguerre and FIR adaptive filtering
% Solves part B

% Ali H. Sayed
% Sep. 2002

clear all
close all

N = 2000;
SNR = 30;
var_v = 10^(-SNR/10);

num  = 0.00692*[0 1 0.673];
den1 = [1 -0.368];
den2 = [1 -0.819];
den3 = [1 -0.995];

epsilon = 1e-6;
lambda = 0.999;

Mlag = 20;

a_vec = 0.850:0.001:0.999;
KK = max(size(a_vec));



L = 100;

for kk=1:KK
  kk
  a = a_vec(kk); %Laguerre pole
  sqa = sqrt(1-abs(a)^2);

  learn_lag = zeros(1,N);
    
  for k = 1:L
   input = randn(N,1);
   d1 = filter(num,den1,input);
   d2 = filter(1,den2,d1);
   d  = filter(1,den3,d2);
   d = d + sqrt(var_v)*randn(N,1);

   e_lag = zeros(1,N);
   u_lag = zeros(1,Mlag);
   w_lag = zeros(Mlag,1); 

   P_lag = (1/epsilon)*eye(Mlag,Mlag);

   for j=1:N
     
     u_lag_p = u_lag;    
     u_lag(1) = a*u_lag(1) + sqa*input(j);  % output of L_o(z)
     for s = 2:Mlag
      u_lag(s) = a*u_lag(s) - a'*u_lag(s-1) + u_lag_p(s-1);
     end
   
     e_lag(j) = d(j) - u_lag*w_lag; 
     gamma_lag = 1/(1+(1/lambda)*u_lag*P_lag*u_lag'); 
     g_lag = (1/lambda)*P_lag*u_lag'*gamma_lag; 
     w_lag = w_lag + g_lag*e_lag(j);  % Laguerre RLS
     P_lag = (1/lambda)*P_lag - (g_lag*(g_lag)'/gamma_lag);
   end
   learn_lag = learn_lag + abs(e_lag).^2;
  end
  emse(kk) = 10*log10(mean(learn_lag(N-200:N)));
end

figure
plot(a_vec,emse,'r');
xlabel('a')
ylabel('dB')
axis tight
grid
