
% Laguerre and FIR adaptive filtering
% Solves part D

% Ali H. Sayed
% Sep. 2002

clear all
close all

N = 2000;
SNR = 30;
var_v = 10^(-SNR/10);

load channel;
h = channel;

epsilon = 1e-6;
lambda = 0.999;

M = max(size(h));
Mfir = M; % filter oder

Mlag_vec = 20:10:100;
KK = max(size(Mlag_vec));

msd = zeros(KK,1);

a = 0.91; %Laguerre pole
sqa = sqrt(1-abs(a)^2);


L = 30;

for kk=1:KK
 kk
 Mlag = Mlag_vec(kk);
 learn_lag = zeros(1,N);
 
  for k = 1:L
  input = randn(N,1);
  d = filter(h,1,input)+ sqrt(var_v)*randn(N,1);

  e_lag = zeros(1,N);
  u_lag = zeros(1,Mlag);
  w_lag = zeros(Mlag,1); 
  P_lag = (1/epsilon)*eye(Mlag,Mlag);
  
  for j=1:N
   u_lag_p = u_lag;    
   u_lag(1) = a*u_lag(1) + sqa*input(j);  % output of L_o(z)
   for s = 2:Mlag
    u_lag(s) = a*u_lag(s) - a'*u_lag(s-1) + u_lag_p(s-1);
   end
   
   e_lag(j) = d(j) - u_lag*w_lag; 
   gamma_lag = 1/(1+(1/lambda)*u_lag*P_lag*u_lag'); 
   g_lag = (1/lambda)*P_lag*u_lag'*gamma_lag; 
   w_lag = w_lag + g_lag*e_lag(j);  % Laguerre RLS
   P_lag = (1/lambda)*P_lag - (g_lag*(g_lag)'/gamma_lag);

  end
  
  u_lag = zeros(1,Mlag);
  input2 = zeros(1,N);
  input2(1) =1;  % Let us now determine the estimated impulse response 

  for j=1:N
   u_lag_p = u_lag;    
   u_lag(1) = a*u_lag(1) + sqa*input2(j);  % output of L_o(z)
   for s = 2:Mlag
    u_lag(s) = a*u_lag(s) - a'*u_lag(s-1) + u_lag_p(s-1);
   end
   
   h_hat(j) = u_lag*w_lag; 
  end
 
  msd(kk) = msd(kk) + norm([h;zeros(N-M,1)]-h_hat');
 end
end

msd = msd/KK;
msd = 20*log10(msd)

plot(Mlag_vec,msd)
xlabel('M');
ylabel('dB')
grid
