
% Active noise control

% Solves part A

% Ali H. Sayed
% Sep. 2002

clear all
close all

F = [1 -1.2 0.75];  

i = 1;
j = sqrt(-1);
for omega = 0:0.01:pi
  resp(i) = F(1) + F(2)*exp(-j*omega) + F(3)*exp(-2*j*omega); % frequency response
  i = i+1;
end

alpha_vec = 0:0.001:0.8;
KK = max(size(alpha_vec));

for k = 1:KK
  alpha = alpha_vec(k);
  x = abs(1-alpha*resp);
  g(k) = max(x);
end

figure
subplot(221)
plot(alpha_vec,g)
xlabel('\alpha');
ylabel('g(\alpha)')
grid
axis tight

subplot(222)
plot(0:0.001:0.1,g(1:101))
xlabel('\alpha');
grid
axis tight
